﻿#include <iostream>
#include <iomanip>
#include <vector>
using namespace std;

const int N = 2;   // số đầu vào
const int M = 5;   // kích cỡ dataset

// bộ dataset: có M dòng, mỗi dòng là một mẫu học
// trên một dòng: x[0] là đầu ra mong muốn (~y), (x1, x2,..., xN) là đầu vào
double x[M][N+1] = {
	{+1,  0.5, 1.5},
	{-1, -0.5, 0.5},
	{+1,  0.5, 0.5}
};

// bộ tham số (w0, w1,..., wN)
vector<double> w(N+1);

// khởi tạo giá trị ban đầu của W, khởi tạo ngẫu nhiên hoặc theo quy luật
void init_w() {
	w[0] = -2; w[1] = 1; w[2] = 2;
}

// hàm hardlims
double hardlims(double s) {
	return (s > 0) ? 1 : -1;
}

// tự lấy dữ liệu ở dòng x[pos] và tính đầu ra của perceptron tương ứng
double perceptron(int pos) {
	double n = w[0];
	for (int i = 1; i <= N; i++) n += w[i]*x[pos][i];
	return hardlims(n);
}

// in dòng header
void print_header() {
	cout << setw(7) << "step";
	for (int i = 0; i <= N; i++) cout << setw(6) << "w" << i;
	for (int i = 1; i <= N; i++) cout << setw(6) << "x" << i;
	cout << setw(7) << "f" << setw(7) << "y" << endl;
}

// in một dòng
void print_row(int step, int test, int f) {
	cout << setw(7) << step;
	for (int i = 0; i <= N; i++) cout << setw(7) << w[i];
	for (int i = 1; i <= N; i++) cout << setw(7) << x[test][i];
	cout << setw(7) << f << setw(7) << x[test][0];
	if (f != x[test][0]) cout << " << update W";
	cout << endl;
}

// minh họa thuật toán huấn luyện Hebb
void hebb_training() {
	print_header();      // in dòng header
	bool more = true;    // có chạy tiếp 1 vòng lặp nữa không?
	int step = 0;        // vòng lặp thứ bao nhiêu?
	while (more) {
		more = false;
		step++;
		// vòng lặp này sẽ duyệt toàn bộ các mẫu trong dataset
		for (int i = 0; i < M; i++) {
			// tính đầu ra của perceptron
			double f = perceptron(i);
			// in dòng tương ứng
			print_row(step, i, f);
			// cập nhật W nếu đầu ra khác đích
			if (f != x[i][0]) {
				more = true;
				w[0] -= f;
				for (int k = 1; k <= N; k++) w[k] -= f*x[i][k];
			}
		}
	}
}

void main() {
    init_w();
	hebb_training();
}